/*
 * nova.h
 *            nova include file.  It is used among the user processes
 *            M. Nomachi             08-JUN-1992
 *              version 0.2   08-JUN-1992 Masaharu NOMACHI   (kek)
 *              version 0.3   22-JUN-1992 Yasuo TAKEUCHI     (T.I.T.)
 *              version 1.01  25-SEP-1992 Masaharu NOMACHI   (kek)
 *              version 1.05  24-NOV-1992 Yasuo TAKEUCHI     (T.I.T.)
 *	        version 2.01  07-MAR-1993 Bob Ball           (UofM)
 */

#define NV_MSGLEN        80             /* message buffer size     */
#define NV_NET_MSGLEN    80             /* message buffer size     */
#define NV_MAXNAME       32             /* max length of NOVA name */

#define LOCAL_NOVA   0
#define NET_NOVA    -1

/*
 * nova descriptor for each path
 */
struct NOVAD
{
  int flag, max_length;
  int priority;
  int request;
  int sd;
  int pid;
  int novaid;
  struct msgbuf *buffer;

#ifdef SGI
#ifndef _BSD_SIGNALS
#define _BSD_SIGNALS
#endif
#endif

#ifdef VXWORKS
  MSG_Q_ID rcv_msgid;
  int rcv_type;
  MSG_Q_ID snd_msgid;
  int snd_type;
#else
  int rcv_msgid, rcv_type, snd_msgid, snd_type;
#endif
  int shmid;
  char *base;                          /* shared memory base address */
  char *net_msg;
};


/*
 * prototype
 */
struct NOVAD *nova_open( );
struct NOVAD *net_nova_open( );

