/*
 * novad.h
 *                     nova daemon include file
 *
 *              version 0.2   08-JUN-1992 Masaharu NOMACHI   (KEK online)
 *              version 0.3   22-JUN-1992 Yasuo TAKEUCHI     (T.I.T.)
 *              version 1.0   09-SEP-1992 Masaharu NOMACHI   (KEK online)
 *              version 1.06  12-APR-1993 Yasuo TAKEUCHI     (T.I.T.)
 *              version 1.07  27-NOV-1993 Yasuo TAKEUCHI     (T.I.T.)
 *		version 2.01  07-MAR-1993 Bob Ball           (UofM)
 */

#ifdef VXWORKS
#include <stdio.h>
#include <msgQLib.h>
#include <memLib.h>
#include <in.h>
#include <socket.h>
#include <sockLib.h>
#include <signal.h>
#include <taskLib.h>
#include "vxshm.h"
#ifndef MSGSTRUCT
#define MSGSTRUCT
struct msgbuf{
  long mtype;
  char mtext[1];
};
#endif
#else
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/msg.h>
#include <stdio.h>
#include <signal.h>
#include <string.h>
#include <stdlib.h>
#include <sys/lock.h>
#include <sys/stat.h>
#define MSG_Q_ID int
#endif
#include "nova.h"
#include "config.h"

#define BUFM_NAME   "bufm "          /* same length with "novad" */
#define SERV_NAME   "serv "

struct nova_def {
  int total_size;
  int buff_size;
  int n_buffer;
  int n_process;
  int control;
  MSG_Q_ID bufmgr_msgid;
  int bufmgr_type;
  MSG_Q_ID daemon_msgid;
  int daemon_type;
  char name[NV_MAXNAME + 1];        /* 1 char for NULL (end of string) */
};
