/*
 * net_collector_fast.c
 *                   Dummy collector for net nova development
 *
 *              version 1.03  09-OCT-1992 Masaharu NOMACHI (KEK)
 */
#include "nova.h"
#include "novanet.h"

#define DEFAULT_HOST          "psuxnc"
#define DEFAULT_NAME          "/tmp/nova"
#define DEFAULT_SIGNIFICANCE  70
#define DEFAULT_LOOP          10
#define DEFAULT_SIZE        1024
#define PRI_COLLECTOR         -1

int buffer[128*1024];

main(argc, argv) int argc; char *argv[];{
  struct NOVAD *nd;
  int length, size, sig;
  int status, loop, i, max_loop;
  char name[NV_MAXNAME + 1];
  char host[NOVA_HOSTNAME_MAX + 1];
  
  max_loop   = (argc > 1) ? atoi(argv[1]) : DEFAULT_LOOP;
  size       = (argc > 2) ? atoi(argv[2]) : DEFAULT_SIZE;
  sig        = (argc > 3) ? atoi(argv[3]) : DEFAULT_SIGNIFICANCE;
  strcpy(host, (argc > 4) ? argv[4] : DEFAULT_HOST);
  strcpy(name, (argc > 5) ? argv[5] : DEFAULT_NAME);
  
  if ((int)(nd = net_nova_open(host, 0, name, PRI_COLLECTOR,1)) == -1) {
    printf("net collector: cannot open %s:%s\n", host, name);
    exit(1);
  }
  
  if (size > sizeof(buffer)) size = sizeof(buffer);

  loop = 0;
  while(1) {
    if (loop>=max_loop) break;
    alarm(10);
    loop++;
    for(i = (size>>2)-1; i >= 0; --i) buffer[i] = loop + i;
    status = net_nova_write(nd, buffer, size, sig);
    if (status<0) {
      printf("net collector: write error status=%d \n",status);
      perror("net collector: write error.");
      break;
    }
  }
  printf("net collector: nomal end. loop=%d size = %d total %dKbyte\n",
	 loop, size,loop*size/1000);
  net_nova_close(nd);
}
