/*
 * ntest.c
 *
 * Nova buffer manager network daemon test program
 *
 *              version 1.02  05-OCT-1992 Masaharu NOMACHI   (KEK online)
 */

#include "novand.h"

char data[] ={"tx:/tmp/nova:100:1:"};

main(argc,argv) int argc; int **argv; {

  int sock, rval, size;
  struct sockaddr_in server;
  struct hostent *hp, *gethostbyname();
  char buf[1024];

  /* Create socket */
  sock = socket(AF_INET, SOCK_STREAM, 0);
  if (sock < 0) {
    printf("** ERROR ** opening stream socket. errno=%X\n",errno);
    exit(1);
  }

  /* Connect socket using name specified by command line. */
  server.sin_family = AF_INET;
  hp = gethostbyname(argv[1]);
  if ( hp == 0 ) {
    printf("** ERROR ** %s: unknown host\n",argv[1]);
    exit(2);
  }
  bcopy(hp->h_addr, &server.sin_addr, hp->h_length);
  if (argc>2) server.sin_port = htons(atoi(argv[2]));
  else        server.sin_port = htons(NOVA_PORT);

  if (connect(sock, &server, sizeof(server)) < 0) {
    printf("** ERROR ** connecting stream socket%X\n",errno);
    exit(1);
  }

  printf(" socket %d\n",sock);

  if (write(sock, data, sizeof(data)) < 0)
    printf("** ERROR ** writing on stream socket%X\n",errno);
  rval = wait_ack(sock);
  if (rval ==0) {
    printf("Connection closed \n");
    close(sock);
    exit(0);
  }
  else if (rval < 0 ) {
    printf("** ERROR ** reading socket %X\n",errno);
    close(sock);
    exit(0);
  }

  while(1) {
    rval = read(sock, buf, 16);
    if (rval ==0) break;
    if (rval < 0 ) printf("** ERROR ** reading socket %X\n",errno);
    rval = sscanf(buf,"nova:%X:",&size);
    rval = read(sock, buf, size);
    if (rval ==0) break;
    if (rval < 0 ) printf("** ERROR ** reading socket %X\n",errno);
    send_ack(sock);
    exec_buf(buf,size);
  }    
  close(sock);
}

exec_buf(data,size) int *data, size; {
  int i;
  printf("(%d)",size);
  for (i=0;i<6;i++) printf("%10d ",data[i]);
  printf("\n");
  return;
}


char ack[] ={"ack:"};

send_ack(msgsock) int msgsock;  {
  return write(msgsock,ack,strlen(ack));
}

wait_ack(msgsock) int msgsock; {
  char buf[32];
  int rval;
  rval = read(msgsock,buf,sizeof(buf));
  if (rval <=0) return rval;
  return rval;
}


