#if 0
From prb@aplexus.jhuapl.edu Mon Sep 20 15:06:18 1993
Received: from BULLDOG.CS.YALE.EDU by SUNED.ZOO.CS.YALE.EDU via SMTP; Mon, 20 Sep 1993 15:06:16 -0400
Received: from mailer.jhuapl.edu (aplmail.jhuapl.edu) by bulldog.CS.YALE.EDU via SMTP; Mon, 20 Sep 1993 15:06:09 -0400
Received: from aplexus.jhuapl.edu by mailer.jhuapl.edu (5.65/DEC-Ultrix/4.3)
	id AA07637; Mon, 20 Sep 1993 15:06:07 -0400
Received: by aplexus.jhuapl.edu (4.1/SMI-4.1)
	id AA18924; Mon, 20 Sep 93 15:06:06 EDT
Date: Mon, 20 Sep 93 15:06:06 EDT
From: prb@aplexus.jhuapl.edu (Paul R. Bade)
Message-Id: <9309201906.AA18924@aplexus.jhuapl.edu>
To: horne-scott
Subject: Re: Exabyte code
Content-Type: X-sun-attachment
Status: R

----------
X-Sun-Data-Type: text
X-Sun-Data-Description: text
X-Sun-Data-Name: text
X-Sun-Content-Lines: 29

> From horne-scott@CS.YALE.EDU Mon Sep 20 14:05:16 1993
> Date: Mon, 20 Sep 1993 14:02:40 -0400
> From: Scott Horne <horne-scott@CS.YALE.EDU>
> To: prb@aplexus.jhuapl.edu
> Subject: Exabyte code
> Content-Length: 435
> 
> One more question about your Exabyte routines:  Do you have any sample
> code lying around that illustrates the invocation of those routines?
> This keeps crashing on me (trap error--uninitialised vector):
> 
> #include "vxWorks.h"
> #include "scsiLib.h"
> #include "exabyte.h"
> #include "errno.h"
> 
> sample()
> {
>     SCSI_PHYS_DEV *device = NULL;
> 
>     exbInit();
>     device = exbOpen(5);
>     exbLoadTape(device);
>     exbClose(device);
> }
> 
> 					--Scott
> 

----------
X-Sun-Data-Type: c-file
X-Sun-Data-Description: c-file
X-Sun-Data-Name: exabyteTest.c
X-Sun-Content-Lines: 698
#endif

/** CT not used
static char resid[] = "$Id$"; **/
/* Developed by Johns Hopkins University Applied Physics Laboratory 1990
 *
 * Project:    
 *
 * Module:     exabyteTest.c
 *
 * Function: 	
 *
 * Resources:
 *          
 *       Hardware Resources:
 *                                                                      
 *       Communication Resources:
 *			comms                              
 *                             
 *       Tasks:
 *        Task Name             Priority                                   
 *        ---------             --------                                  
 *                      None
 *                                                                      
 *       Interrupt Vectors:                                       
 *        Name                  Vector                           
 *        ---------             ------                          
 *	  		None
 *                                                            
 *       Libraries Required:                                 
 *        Library Name          Description                 
 *        ------------          -----------                
 *			comms
 *			VxWorks
 *
 *       Entry Points:                                                        
 *       -------------                                                     
 *
 *	Host System:	VxWorks 5.0.2
 *	Language:	C
 *	Modifications:  $Log$
 *
*/


/************************************
*          Module Includes          *
************************************/

#include "vxWorks.h"
#include "scsiLib.h"
#include "exabyte.h"
#include "errno.h"
#include "logLib.h"
#include "sysLib.h"
#include "taskLib.h"
#include "tickLib.h"
/************************************
*           Local Defines           *
************************************/

#define BLK_SIZE		49152 
#define ITERATIONS		25 

/************************************
*          Local Functions          *
************************************/


/************************************
*          Local Variables          *
************************************/



/*################*/
/* Module Externs -- this should be in the includes file*/
/*################*/

/* Scsi Controller Created in sysLib.c */

extern SCSI_CTRL	*pSysScsiCtrl;

/*################*/
/* Module Globals -- this should be in the includes file */
/*################*/
int 		*data_send;
int 		*data_recv;

unsigned char	test_data	[17][BLK_SIZE];
unsigned char	read_data	[BLK_SIZE];
unsigned char	timing_data	[BLK_SIZE];
float		rate		[100];
extern unsigned int 	deltatick;
unsigned int	totaltick;

/*#################*/
/* Module Routines */
/*#################*/

void 		timingTest	();

int 		testExb();
static void 	showTapeStatus();


/*******************************************************************************
*
* This task tests the exabyte package.
*
*-------------------------------------------------------------------------------
*
* Function:	void TEST_TAPES ()
*
*-------------------------------------------------------------------------------
*
* Description:
*
*-------------------------------------------------------------------------------
*
* Returns:	
*
*******************************************************************************/


int testExb ()

{
	SCSI_PHYS_DEV 	*tape5;
	EXB_STATUS 	device_status;
	EXB_SENSE_DATA 	sense_buffer;
	int 		status; 
	int 		byte_count; 
	int 		error_count; 
	int 		i;
	int		j;
	int		exit_read_loop;

	logMsg ("testExb: Going to call Scsi_Init\n",0,0,0,0,0,0);

	status = exbInit ();
	if (status != OK ) 
	{
	  logMsg ("testExb: Scsi_Init failed initialization\n",0,0,0,0,0,0);
          return (ERROR);
	}
	
	logMsg ("testExb: Going to open tape unit\n",0,0,0,0,0,0);

	tape5 = exbOpen (5);

	if (tape5 == (SCSI_PHYS_DEV *) -1)
	{
	  logMsg ("testExb: exbOpen failed to open tape unit\n",0,0,0,0,0,0);
          return (ERROR);
	} 

 
/***********************************/
        /* Wait for Exabyte to be ready */

        error_count = 0;

        /*logMsg ("exbOpen:going to call test ready, going to delay 2 min. first\n");
        taskDelay (7200);*/

        logMsg ("exbOpen:going to call test ready\n",0,0,0,0,0,0);

        device_status = exbTestReady (tape5);
        while   ((device_status.errorCode == EXB_UNIT_ATTENTION)
                || (device_status.errorCode == EXB_NOT_READY)
                || (device_status.errorCode == EXB_BUSY))

        {
                logMsg ("waiting for exabyte drive to be ready\n",0,0,0,0,0,0);
                /* logMsg ("exabyte drive status = %x\n", device_status.errorCode
); */
                taskDelay (sysClkRateGet());     /* delay 1 second */
                error_count += 1;

                if (error_count >= 300)
                {
                        logMsg ("Exabyte drive not ready after 5 minutes, giving up/n",0,0,0,0,0,0);
                        exbClose (tape5);
                        return (ERROR);
                }
 
                device_status = exbTestReady (tape5);
        } /* while */
 
        if (device_status.errorCode != EXB_NO_ERROR)
        {
                logMsg ("Error testing for exabyte to be ready => giving up the ship\n",0,0,0,0,0,0);
                logMsg ("device_status.errorCode = 0x%x\n", device_status.errorCode,0,0,0,0,0);
                exbClose (tape5);
                return (ERROR);
        }
/***********************************/
 
	/* Demonstrate Test Unit Ready command */

	device_status =exbTestReady (tape5);
	if (device_status.senseDataValid)
	{
		showTapeStatus (device_status);
	}
	
	/* Demonstrate Request Sense command */

	device_status = exbRequestSense (tape5, &sense_buffer); 

	while ((device_status.errorCode != EXB_NO_ERROR)
		&& (device_status.errorCode != EXB_MEDIUM_ERROR)
		&& (device_status.errorCode != EXB_HARDWARE_ERROR)
		&& (device_status.errorCode != EXB_ILLEGAL_REQUEST)
		&& (device_status.errorCode != EXB_DATA_PROTECT)
		&& (device_status.errorCode != EXB_BLANK_CHECK)
		&& (device_status.errorCode != EXB_EXABYTE_UNIQUE)
		&& (device_status.errorCode != EXB_ABORTED_COMMAND)
		&& (device_status.errorCode != EXB_VOLUME_OVERFLOW)
		&& (device_status.errorCode != EXB_NO_SENSE))
	{
		device_status = exbRequestSense (tape5, &sense_buffer); 
	}
 
	if (sense_buffer.writeProtect)
	{
		logMsg ("testExb: write Protected \n",0,0,0,0,0,0);
	}
	if (sense_buffer.endOfMedia)
	{
		logMsg ("testExb: end of media\n",0,0,0,0,0,0);
	}
	if (sense_buffer.filemark)
	{
		logMsg ("testExb: filemark\n",0,0,0,0,0,0);
	}

	for (i=0; i<16; i++)
	{
		logMsg ("testExb: Building test data block =>%d\n", i,0,0,0,0,0);
		for (j=0; j<BLK_SIZE; j++)
		{
			test_data[i][j] = (j && 0xff);
		}

		logMsg ("testExb: Writing test data block =>%d\n", i,0,0,0,0,0);
		byte_count = BLK_SIZE;

		device_status = exbWrite (tape5,
						(unsigned char*)&test_data[i],
						&byte_count);

		while ((device_status.errorCode != EXB_NO_ERROR)
			&& (device_status.errorCode != EXB_MEDIUM_ERROR)
			&& (device_status.errorCode != EXB_HARDWARE_ERROR)
			&& (device_status.errorCode != EXB_ILLEGAL_REQUEST)
			&& (device_status.errorCode != EXB_DATA_PROTECT)
			&& (device_status.errorCode != EXB_BLANK_CHECK)
			&& (device_status.errorCode != EXB_EXABYTE_UNIQUE)
			&& (device_status.errorCode != EXB_ABORTED_COMMAND)
			&& (device_status.errorCode != EXB_VOLUME_OVERFLOW)
			&& (device_status.errorCode != EXB_NO_SENSE))
		{
			device_status = exbWrite (tape5,
						(unsigned char*)&test_data[i],
							&byte_count);
		}
 
		if (device_status.errorCode != EXB_NO_ERROR) 
		{
			logMsg ("testExb: Write failed\n",0,0,0,0,0,0);
			showTapeStatus (device_status);
			return(ERROR);
		}
	}/* end for */

	logMsg ("testExb: Going to write a filemark\n",0,0,0,0,0,0);
	device_status = exbWriteFilemark (tape5);

	while ((device_status.errorCode != EXB_NO_ERROR)
		&& (device_status.errorCode != EXB_MEDIUM_ERROR)
		&& (device_status.errorCode != EXB_HARDWARE_ERROR) 
		&& (device_status.errorCode != EXB_ILLEGAL_REQUEST)
		&& (device_status.errorCode != EXB_DATA_PROTECT) 
		&& (device_status.errorCode != EXB_BLANK_CHECK)
		&& (device_status.errorCode != EXB_EXABYTE_UNIQUE) 
		&& (device_status.errorCode != EXB_ABORTED_COMMAND)
		&& (device_status.errorCode != EXB_VOLUME_OVERFLOW) 
		&& (device_status.errorCode != EXB_NO_SENSE))
	{
 		device_status = exbWriteFilemark (tape5);
	}

	if (device_status.errorCode != EXB_NO_ERROR)
	{
		logMsg ("testExb: Write filemark failed\n",0,0,0,0,0,0);
		showTapeStatus (device_status);
	}

	logMsg ("testExb: going to delay 5 seconds before I try to rewind tape\n",0,0,0,0,0,0);
	taskDelay (300);

	logMsg ("testExb: Going to rewind the tape\n",0,0,0,0,0,0);
	device_status = exbRewind (tape5);

	while ((device_status.errorCode != EXB_NO_ERROR)
		&& (device_status.errorCode != EXB_MEDIUM_ERROR)
		&& (device_status.errorCode != EXB_HARDWARE_ERROR) 
		&& (device_status.errorCode != EXB_ILLEGAL_REQUEST)
		&& (device_status.errorCode != EXB_DATA_PROTECT) 
		&& (device_status.errorCode != EXB_BLANK_CHECK)
		&& (device_status.errorCode != EXB_EXABYTE_UNIQUE) 
		&& (device_status.errorCode != EXB_ABORTED_COMMAND)
		&& (device_status.errorCode != EXB_VOLUME_OVERFLOW) 
		&& (device_status.errorCode != EXB_NO_SENSE))
	{
		device_status = exbRewind (tape5); 
	}

	if (device_status.errorCode != EXB_NO_ERROR)
	{
		logMsg ("testExb: rewind tape failed\n",0,0,0,0,0,0);
		showTapeStatus (device_status);
	}

	logMsg ("testExb: tape rewound\n",0,0,0,0,0,0);

	error_count 	= 0;
	i 		= 0;
	exit_read_loop 	= 0;

	while ((i<16) && (!exit_read_loop))
	{
		/* Clear buffer to read in test data */

		for (j=0; j<BLK_SIZE; j++)
		{
			read_data[j] = 0;
		}

		logMsg ("testExb: Reading test data block => %d\n", i,0,0,0,0,0);
#if FALSE
		byte_count = (BLK_SIZE + 100);
#else
		byte_count = (BLK_SIZE);
#endif

		device_status = exbRead (tape5,
						read_data,
						&byte_count);

		while ((device_status.errorCode != EXB_NO_ERROR)
			&& (device_status.errorCode != EXB_MEDIUM_ERROR)
			&& (device_status.errorCode != EXB_HARDWARE_ERROR) 
			&& (device_status.errorCode != EXB_ILLEGAL_REQUEST)
			&& (device_status.errorCode != EXB_DATA_PROTECT) 
			&& (device_status.errorCode != EXB_BLANK_CHECK)
			&& (device_status.errorCode != EXB_EXABYTE_UNIQUE) 
			&& (device_status.errorCode != EXB_ABORTED_COMMAND)
			&& (device_status.errorCode != EXB_VOLUME_OVERFLOW) 
			&& (device_status.errorCode != EXB_NO_SENSE))
		{
			device_status = exbRead (tape5,
						read_data,
						&byte_count);
		}

		if (device_status.errorCode != EXB_NO_ERROR) 
		{
			logMsg ("testExb: Read failed\n",0,0,0,0,0,0);
			showTapeStatus (device_status);
			return(ERROR);
		}
		if (byte_count != BLK_SIZE) /* perhaps at EOF */
		{
			logMsg ("testExb: Read failed, read only 0x%x bytes\n",0,0,0,0,0,0);
			logMsg ("testExb: Should have read 0x%x bytes\n",0,0,0,0,0,0);
			showTapeStatus (device_status);
			return(ERROR);
		}

		logMsg ("testExb: Verifying test data block => %d\n", i,0,0,0,0,0);
		for (j=0; j<BLK_SIZE; j++)
		{
			if ((read_data[j] != (j && 0xff)) && (error_count < 10))
			{
				error_count = error_count+ 1;
				logMsg ("testExb: Data error at data block => %d, byte => %d\n", i, j,0,0,0,0);
				logMsg ("Data was a => %c, should be a %c\n", read_data[j], (j && 0xff),0,0,0,0);
			}
			if (error_count >= 10)
			{
				logMsg ("testExb: Too many errors, aborting test\n",0,0,0,0,0,0);
				exit_read_loop = 1;
				break;
			}
		}/* end for */
		i=i+1;
	}/* end while */

	logMsg ("testExb:Test complete => %d errors\n", error_count,0,0,0,0,0);

	return(0);
}/* end testExb */



/*******************************************************************************
*
* 
*
*-------------------------------------------------------------------------------
*
* Function:	static void	showTapeStatus (status)
*
*-------------------------------------------------------------------------------
*
* Description:
*
*-------------------------------------------------------------------------------
*
* Returns:	
*
*******************************************************************************/


static void	showTapeStatus (status)
EXB_STATUS status;
{
	if (status.senseDataValid)
	{
		if (status.tapeNotPresent = FALSE)
		{
			logMsg ("No tape in tape drive\n",0,0,0,0,0,0);
		}

		if (status.writeProtect)
		{
			logMsg ("Tape is write protected\n",0,0,0,0,0,0);
		}
		else
		{
			logMsg ("Tape is not write protected\n",0,0,0,0,0,0);
		}

		if (status.endOfMedia)
		{
			logMsg ("End of Media\n",0,0,0,0,0,0);
		}

		if (status.bot)
		{
			logMsg ("Beginning of Tape\n",0,0,0,0,0,0);
		}

		if (status.peot)
		{
			logMsg ("Physical end of Tape\n",0,0,0,0,0,0);
		}

		if (status.filemark)
		{
			logMsg ("Filemark\n",0,0,0,0,0,0);
		}

		if (status.ili)
		{
			logMsg ("illegal length on last command\n",0,0,0,0,0,0);
		}
	}/* end if */
	
	switch (status.errorCode)
	{ 
		case EXB_NO_ERROR:
			logMsg ("No error on last command\n",0,0,0,0,0,0);
			break;
		case EXB_BUSY:
			logMsg ("Scsi bus busy error on last command\n",0,0,0,0,0,0);
			break;
		case EXB_NOT_READY:
			logMsg ("Tape drive busy error on last command\n",0,0,0,0,0,0);
			break;
		case EXB_MEDIUM_ERROR:
			logMsg ("Medium error on last command\n",0,0,0,0,0,0);
			break;
		case EXB_HARDWARE_ERROR:
			logMsg ("Hardware error on last command\n",0,0,0,0,0,0);
			break;
		case EXB_ILLEGAL_REQUEST:
			logMsg ("Illegal Request error on last command\n",0,0,0,0,0,0);
			break;
		case EXB_UNIT_ATTENTION:
			logMsg ("Unit Attention error on last command\n",0,0,0,0,0,0);
			logMsg ("Media may have been changed by the operator\n",0,0,0,0,0,0);
			break;
		case EXB_DATA_PROTECT:
			logMsg ("Data protect error on last command\n",0,0,0,0,0,0);
			break;
		case EXB_BLANK_CHECK:
			logMsg ("Blank check error on last command\n",0,0,0,0,0,0);
			break;
		case EXB_EXABYTE_UNIQUE:
			logMsg ("Exabyte unique error on last command\n",0,0,0,0,0,0);
			break;
		case EXB_ABORTED_COMMAND:
			logMsg ("Aborted command error on last command\n",0,0,0,0,0,0);
			break;
		case EXB_VOLUME_OVERFLOW:
			logMsg ("Volume overflow error on last command\n",0,0,0,0,0,0);
			break;
		case EXB_NO_SENSE:
			logMsg ("No_Sense error on last command\n",0,0,0,0,0,0);
			break;
		default:
			logMsg ("Not legal value for status.errorCode\n",0,0,0,0,0,0);
	}/* end switch */
 }/* end showTapeStatus */



/*******************************************************************************
*
* 
*
*-------------------------------------------------------------------------------
*
* Function:	void timingTest ()
*
*-------------------------------------------------------------------------------
*
* Description:
*
*
*-------------------------------------------------------------------------------
*
* Returns:	
*
*******************************************************************************/

void timingTest ()

{
	int 		status; 
	SCSI_PHYS_DEV 	*tape5;
	EXB_STATUS 	device_status;
	int 		byte_count; 
/** CT unused	int 		error_count; **/
	EXB_SENSE_DATA 	sense_buffer;
	int 		i;
	int 		j;
/** CT unused	int		exit_read_loop;  **/
/** CT unused 	unsigned int 	timecount1;
	unsigned int	timecount2;  **/
	float 		total=0;
	float 		tim;
	unsigned int 	time_count1;
	unsigned int	time_count2;
	unsigned int	delta_tick;

	logMsg ("timingTest: Going to call Scsi_Init\n",0,0,0,0,0,0);

	status = exbInit ();

	if (status != OK ) 
	{
		logMsg ("timingTest: Scsi_Init failed initialization\n",0,0,0,0,0,0);
	}	

	logMsg ("timingTest: Going to open tape unit\n",0,0,0,0,0,0);

	tape5 = exbOpen (5);

	if (tape5 == (SCSI_PHYS_DEV *) -1)
	{
		logMsg ("timingTest: exbOpen failed to open tape unit\n",0,0,0,0,0,0);
	}
	 
	/* Demonstrate Test Unit Ready command */

	device_status =exbTestReady (tape5);
	if (device_status.senseDataValid)
	{
		showTapeStatus (device_status);
	}

	/* Demonstrate Request Sense command */

	device_status = exbRequestSense (tape5, &sense_buffer); 

	while ((device_status.errorCode != EXB_NO_ERROR)
		&& (device_status.errorCode != EXB_MEDIUM_ERROR)
		&& (device_status.errorCode != EXB_HARDWARE_ERROR) 
		&& (device_status.errorCode != EXB_ILLEGAL_REQUEST)
		&& (device_status.errorCode != EXB_DATA_PROTECT) 
		&& (device_status.errorCode != EXB_BLANK_CHECK)
		&& (device_status.errorCode != EXB_EXABYTE_UNIQUE) 
		&& (device_status.errorCode != EXB_ABORTED_COMMAND)
		&& (device_status.errorCode != EXB_VOLUME_OVERFLOW) 
		&& (device_status.errorCode != EXB_NO_SENSE))
	{
		device_status = exbRequestSense (tape5, &sense_buffer); 
	}
 
	if (sense_buffer.endOfMedia)
	{
		logMsg ("timingTest: end of media\n",0,0,0,0,0,0);
	}
	if (sense_buffer.filemark)
	{
		logMsg ("timingTest: filemark\n",0,0,0,0,0,0);
	}

	logMsg ("testExb: Going to write a filemark\n",0,0,0,0,0,0);
	device_status = exbWriteFilemark (tape5);

	while ((device_status.errorCode != EXB_NO_ERROR)
		&& (device_status.errorCode != EXB_MEDIUM_ERROR)
		&& (device_status.errorCode != EXB_HARDWARE_ERROR) 
		&& (device_status.errorCode != EXB_ILLEGAL_REQUEST)
		&& (device_status.errorCode != EXB_DATA_PROTECT) 
		&& (device_status.errorCode != EXB_BLANK_CHECK)
		&& (device_status.errorCode != EXB_EXABYTE_UNIQUE) 
		&& (device_status.errorCode != EXB_ABORTED_COMMAND)
		&& (device_status.errorCode != EXB_VOLUME_OVERFLOW) 
		&& (device_status.errorCode != EXB_NO_SENSE))
	{
		device_status = exbWriteFilemark (tape5);
	}

	if (device_status.errorCode != EXB_NO_ERROR)
	{
		logMsg ("testExb: Write filemark failed\n",0,0,0,0,0,0);
		showTapeStatus (device_status);
	}

	logMsg ("timingTest: going to start sending data to the tape\n",0,0,0,0,0,0);
	for (j=0; j< BLK_SIZE; j++)
	{
		timing_data[j] = 3;
	}
 
	for (i=0; i<20; i++)
	{
		totaltick = 0;
		for (j=0; j < ITERATIONS; j++)
		{
			byte_count = BLK_SIZE;
			time_count1 = tickGet ();

			device_status = exbWrite (tape5,
							timing_data,
							&byte_count);
			while ((device_status.errorCode != EXB_NO_ERROR)
				&& (device_status.errorCode != EXB_MEDIUM_ERROR)
				&& (device_status.errorCode != EXB_HARDWARE_ERROR)
				&& (device_status.errorCode != EXB_ILLEGAL_REQUEST)
				&& (device_status.errorCode != EXB_DATA_PROTECT)
				&& (device_status.errorCode != EXB_BLANK_CHECK)
				&& (device_status.errorCode != EXB_EXABYTE_UNIQUE)
				&& (device_status.errorCode != EXB_ABORTED_COMMAND)
				&& (device_status.errorCode != EXB_VOLUME_OVERFLOW)
				&& (device_status.errorCode != EXB_NO_SENSE))
			{
					device_status = exbWrite (tape5,
									timing_data,
									&byte_count);
			}

			time_count2 = tickGet ();
			delta_tick= time_count2 - time_count1;
			totaltick+= deltatick;
		}

		if (device_status.errorCode != EXB_NO_ERROR) 
		{
			logMsg ("timingTest: Write failed\n",0,0,0,0,0,0);
			showTapeStatus (device_status);
			return;
		}

		tim = (totaltick/(float) 60);
		rate[i] = (float) (BLK_SIZE*ITERATIONS)/tim;

		if (i==0)
		{
			logMsg ("timingTest: sent the first block out; going to delay 40 seconds\n",0,0,0,0,0,0);
			taskDelay (2400);	
		}
 
		logMsg ("timingTest: finished block # %d\n", i,0,0,0,0,0);
		logMsg ("the number of bytes sent is %d\n", BLK_SIZE*ITERATIONS,0,0,0,0,0);
		logMsg ("the total number of ticks is %d\n", totaltick,0,0,0,0,0);
		logMsg ("the total time elapsed is %.5f seconds\n", tim,0,0,0,0,0);
	} /* end for */

	for (i=0; i< 20; i++)
	{
		logMsg ("the value of the instantaneous rate for block #%d is %.5f bytes/sec\n", i, rate[i],0,0,0,0);
		total+=rate[i];
	}

	logMsg ("the overall rate is %.5f bytes/sec\n", (total/20),0,0,0,0,0);
}

