#define	O_fna	1
#define	O_A	2
#define	O_S	3
#define	O_T	4
#define	O_buff	5		/* (PTR)+	*/
#define	O_head	6		/* HEADER(n)	*/
#define	O_labl	7		/* label	*/
#define	O_PTR	8
#define	O_REM	9		/* REMAINDER	*/
#define	O_TIM	10		/* TIMER	*/
#define	O_CNT	11		/* COUNT	*/
#define	O_num	12		/* number 	*/
#define O_CAM   13		/* camac status */
#define	O_dat	14		/* #data	*/
#define	O_siz	15		/* code size	*/

#define O_high	128
#define O_low	64
#define	O_dL	O_dat+O_low	/* data low	*/
#define	O_dH	O_dat+O_high 	/* data high	*/
#define	O_AN	O_fna+O_low	/* camac AN	*/
#define	O_F	O_fna+O_high 	/* camac  F	*/

#define D_nd	1
#define D_dw	2	/*  .w  */
#define D_w	3	/* {.w} */
#define D_dl	4	/*  .l  */
#define D_l	5	/* {.l} */


struct mn_tbl {
	char		*name;
	int		cont;		/* 1=continue 0=end		*/
	int		dsize;		/* D_nd, D_dw, D_dl, D_w, D_d	*/
	int		osize;		/* # of operand 		*/
	int		otype[2];	/* operand type code		*/
	int		csize;		/* code size			*/
    unsigned short	code[6];	/* op code + operand code	*/
					/*    +-------------------+	*/
					/*    |	code[1] | code[0] |	*/
					/*    +-------------------+	*/
					/*    |	     code[2]	  |	*/
					/*    +-------------------+	*/
					/*    |	     code[3]	  |	*/
					/*    +-------------------+	*/
					/*    |	     code[4]	  |	*/
					/*    +-------------------+	*/
					/*    |	     code[5]	  |	*/
					/*    +-------------------+	*/
					/*   15         7         0	*/
};


struct mn_tbl mntable[100] = {

#ifdef camasm_VAX

{"READ",     1, D_w,  1, O_fna,  O_buff, 2,  1, O_siz, O_fna,    0,     0, 0 },
{"READ",     1, D_dl, 1, O_fna,  O_buff, 2,  2, O_siz, O_fna,    0,     0, 0 },
{"READ",     1, D_w,  2, O_fna,  O_A,    2,  3, O_siz, O_fna,    0,     0, 0 },
{"READ",     0, D_dl, 2, O_fna,  O_A,    2,  4, O_siz, O_fna,    0,     0, 0 },
{"WRITE",    1, D_w,  2, O_dat,  O_fna,  3,  5, O_siz, O_fna,  O_dat,   0, 0 },
{"WRITE",    1, D_dl, 2, O_dat,  O_fna,  4,  6, O_siz, O_fna,  O_dL,  O_dH,0 },
{"WRITE",    1, D_w,  2, O_A,    O_fna,  2,  7, O_siz, O_fna,    0,     0, 0 },
{"WRITE",    0, D_dl, 2, O_A,    O_fna,  2,  8, O_siz, O_fna,    0,     0, 0 },
{"NDT",      0, D_nd, 1, O_fna,    0,    2,  9, O_siz, O_fna,    0,     0, 0 },
{"SETCRATE", 1, D_nd, 1, O_A,      0,    1, 10, O_siz,   0,      0,     0, 0 },
{"SETCRATE", 0, D_nd, 1, O_dat,    0,    2, 11, O_siz, O_dat,    0,     0, 0 },
{"GENZ",     0, D_nd, 0,   0,      0,    1, 12, O_siz,   0,      0,     0, 0 },
{"GENC",     0, D_nd, 0,   0,      0,    1, 13, O_siz,   0,      0,     0, 0 },
{"REMI",     0, D_nd, 0,   0,      0,    1, 14, O_siz,   0,      0,     0, 0 },
{"SETI",     0, D_nd, 0,   0,      0,    1, 15, O_siz,   0,      0,     0, 0 },
{"ENBINT",   0, D_nd, 0,   0,      0,    1, 16, O_siz,   0,      0,     0, 0 },
{"DSBINT",   0, D_nd, 0,   0,      0,    1, 17, O_siz,   0,      0,     0, 0 },
{"QWAIT",    0, D_nd, 2, O_fna,  O_dat,  3, 18, O_siz, O_fna,  O_dat,   0, 0 },
{"QS",       1, D_w,  2, O_fna,  O_dat,  3, 19, O_siz, O_fna,  O_dat,   0, 0 },
{"QS",       1, D_dl, 2, O_fna,  O_dat,  3, 20, O_siz, O_fna,  O_dat,   0, 0 },
{"QS",       1, D_w,  2, O_fna,  O_A,    2, 21, O_siz, O_fna,    0,     0, 0 },
{"QS",       0, D_dl, 2, O_fna,  O_A,    2, 22, O_siz, O_fna,    0,     0, 0 },
{"AS",       1, D_w,  2, O_fna,  O_dat,  3, 23, O_siz, O_fna,  O_dat,   0, 0 },
{"AS",       1, D_dl, 2, O_fna,  O_dat,  3, 24, O_siz, O_fna,  O_dat,   0, 0 },
{"AS",       1, D_w,  2, O_fna,  O_A,    2, 25, O_siz, O_fna,    0,     0, 0 },
{"AS",       0, D_dl, 2, O_fna,  O_A,    2, 26, O_siz, O_fna,    0,     0, 0 },
{"IGQ",      1, D_w,  2, O_fna,  O_dat,  3, 27, O_siz, O_fna,  O_dat,   0, 0 },
{"IGQ",      1, D_dl, 2, O_fna,  O_dat,  3, 28, O_siz, O_fna,  O_dat,   0, 0 },
{"IGQ",      1, D_w,  2, O_fna,  O_A,    2, 29, O_siz, O_fna,    0,     0, 0 },
{"IGQ",      0, D_dl, 2, O_fna,  O_A,    2, 30, O_siz, O_fna,    0,     0, 0 },
#endif

#ifdef camasm_PC98
{"READ",     1, D_w,  1, O_fna,  O_buff, 3,  1, O_siz, O_AN, O_F,   0,    0 },
{"READ",     1, D_dl, 1, O_fna,  O_buff, 3,  2, O_siz, O_AN, O_F,   0,    0 },
{"READ",     1, D_w,  2, O_fna,  O_A,    3,  3, O_siz, O_AN, O_F,   0,    0 },
{"READ",     0, D_dl, 2, O_fna,  O_A,    3,  4, O_siz, O_AN, O_F,   0,    0 },
{"WRITE",    1, D_w,  2, O_dat,  O_fna,  4,  5, O_siz, O_AN, O_F, O_dat,  0 },
{"WRITE",    1, D_dl, 2, O_dat,  O_fna,  5,  6, O_siz, O_AN, O_F, O_dL, O_dH},
{"WRITE",    1, D_w,  2, O_A,    O_fna,  3,  7, O_siz, O_AN, O_F,   0,    0 },
{"WRITE",    0, D_dl, 2, O_A,    O_fna,  3,  8, O_siz, O_AN, O_F,   0,    0 },
{"NDT",      0, D_nd, 1, O_fna,    0,    3,  9, O_siz, O_AN, O_F,   0,    0 },
{"SETCRATE", 1, D_nd, 1, O_A,      0,    1, 10, O_siz,   0,    0,   0,    0 },
{"SETCRATE", 0, D_nd, 1, O_dat,    0,    2, 11, O_siz, O_dat,  0,   0,    0 },
{"GENZ",     0, D_nd, 0,   0,      0,    1, 12, O_siz,   0,    0,   0,    0 },
{"GENC",     0, D_nd, 0,   0,      0,    1, 13, O_siz,   0,    0,   0,    0 },
{"REMI",     0, D_nd, 0,   0,      0,    1, 14, O_siz,   0,    0,   0,    0 },
{"SETI",     0, D_nd, 0,   0,      0,    1, 15, O_siz,   0,    0,   0,    0 },
{"ENBINT",   0, D_nd, 0,   0,      0,    1, 16, O_siz,   0,    0,   0,    0 },
{"DSBINT",   0, D_nd, 0,   0,      0,    1, 17, O_siz,   0,    0,   0,    0 },
{"QWAIT",    0, D_nd, 2, O_fna,  O_dat,  4, 18, O_siz, O_AN, O_F, O_dat,  0 },
{"QS",       1, D_w,  2, O_fna,  O_dat,  4, 19, O_siz, O_AN, O_F, O_dat,  0 },
{"QS",       1, D_dl, 2, O_fna,  O_dat,  4, 20, O_siz, O_AN, O_F, O_dat,  0 },
{"QS",       1, D_w,  2, O_fna,  O_A,    3, 21, O_siz, O_AN, O_F,   0,    0 },
{"QS",       0, D_dl, 2, O_fna,  O_A,    3, 22, O_siz, O_AN, O_F,   0,    0 },
{"AS",       1, D_w,  2, O_fna,  O_dat,  4, 23, O_siz, O_AN, O_F, O_dat,  0 },
{"AS",       1, D_dl, 2, O_fna,  O_dat,  4, 24, O_siz, O_AN, O_F, O_dat,  0 },
{"AS",       1, D_w,  2, O_fna,  O_A,    3, 25, O_siz, O_AN, O_F,   0,    0 },
{"AS",       0, D_dl, 2, O_fna,  O_A,    3, 26, O_siz, O_AN, O_F,   0,    0 },
{"IGQ",      1, D_w,  2, O_fna,  O_dat,  4, 27, O_siz, O_AN, O_F, O_dat,  0 },
{"IGQ",      1, D_dl, 2, O_fna,  O_dat,  4, 28, O_siz, O_AN, O_F, O_dat,  0 },
{"IGQ",      1, D_w,  2, O_fna,  O_A,    3, 29, O_siz, O_AN, O_F,   0,    0 },
{"IGQ",      0, D_dl, 2, O_fna,  O_A,    3, 30, O_siz, O_AN, O_F,   0,    0 },
#endif



{"MOVE",     1, D_l,  2, O_A,    O_S,    1, 35, O_siz,   0,      0,     0, 0 },
{"MOVE",     1, D_l,  2, O_A,    O_T,    1, 36, O_siz,   0,      0,     0, 0 },
{"MOVE",     1, D_l,  2, O_S,    O_A,    1, 37, O_siz,   0,      0,     0, 0 },
{"MOVE",     1, D_l,  2, O_S,    O_T,    1, 38, O_siz,   0,      0,     0, 0 },
{"MOVE",     1, D_l,  2, O_T,    O_A,    1, 39, O_siz,   0,      0,     0, 0 },
{"MOVE",     1, D_l,  2, O_T,    O_S,    1, 40, O_siz,   0,      0,     0, 0 },
{"MOVE",     1, D_l,  2, O_dat,  O_A,    3, 41, O_siz, O_dL,   O_dH,    0, 0 },
{"MOVE",     1, D_l,  2, O_dat,  O_S,    3, 42, O_siz, O_dL,   O_dH,    0, 0 },
{"MOVE",     1, D_l,  2, O_dat,  O_T,    3, 43, O_siz, O_dL,   O_dH,    0, 0 },
{"MOVE",     1, D_w,  2, O_A,    O_buff, 1, 44, O_siz,   0,      0,     0, 0 },
{"MOVE",     1, D_dl, 2, O_A,    O_buff, 1, 45, O_siz,   0,      0,     0, 0 },
{"MOVE",     1, D_w,  2, O_dat,  O_buff, 2, 46, O_siz, O_dat,    0,     0, 0 },
{"MOVE",     1, D_dl, 2, O_dat,  O_buff, 3, 47, O_siz, O_dL,   O_dH,    0, 0 },
{"MOVE",     1, D_w,  2, O_A,    O_head, 2, 48, O_siz, O_head,   0,     0, 0 },
{"MOVE",     1, D_w,  2, O_head, O_A,    2, 49, O_siz, O_head,   0,     0, 0 },
{"MOVE",     0, D_w,  2, O_dat,  O_head, 3, 50, O_siz, O_head, O_dat,   0, 0 },

{"LOAD",     1, D_nd, 1, O_PTR,    0,    1, 51, O_siz,   0,      0,     0, 0 },
{"LOAD",     1, D_nd, 1, O_REM,    0,    1, 52, O_siz,   0,      0,     0, 0 },
{"LOAD",     1, D_nd, 1, O_TIM,    0,    1, 53, O_siz,   0,      0,     0, 0 },
{"LOAD",     1, D_nd, 1, O_CNT,    0,    1, 54, O_siz,   0,      0,     0, 0 },
{"LOAD",     0, D_nd, 1, O_CAM,    0,    1, 55, O_siz,   0,      0,     0, 0 },

{"HEADER",   0, D_nd, 1, O_dat,    0,    2, 56, O_siz, O_dat,    0,     0, 0 },
{"EXCHG",    0, D_nd, 2, O_A,    O_T,    1, 57, O_siz,   0,      0,     0, 0 },
{"SWAP",     0, D_nd, 1, O_A,      0,    1, 58, O_siz,   0,      0,     0, 0 },

{"BIS",      1, D_l,  2, O_A,    O_T,    1, 59, O_siz,   0,      0,     0, 0 },
{"BIS",      1, D_l,  2, O_T,    O_A,    1, 60, O_siz,   0,      0,     0, 0 },
{"BIS",      1, D_l,  2, O_dat,  O_A,    3, 61, O_siz, O_dL,   O_dH,    0, 0 },
{"BIS",      0, D_l,  2, O_dat,  O_T,    3, 62, O_siz, O_dL,   O_dH,    0, 0 },
{"BIC",      1, D_l,  2, O_A,    O_T,    1, 63, O_siz,   0,      0,     0, 0 },
{"BIC",      1, D_l,  2, O_T,    O_A,    1, 64, O_siz,   0,      0,     0, 0 },
{"BIC",      1, D_l,  2, O_dat,  O_A,    3, 65, O_siz, O_dL,   O_dH,    0, 0 },
{"BIC",      0, D_l,  2, O_dat,  O_T,    3, 66, O_siz, O_dL,   O_dH,    0, 0 },
{"ADD",      1, D_l,  2, O_A,    O_T,    1, 67, O_siz,   0,      0,     0, 0 },
{"ADD",      1, D_l,  2, O_T,    O_A,    1, 68, O_siz,   0,      0,     0, 0 },
{"ADD",      1, D_l,  2, O_dat,  O_A,    3, 69, O_siz, O_dL,   O_dH,    0, 0 },
{"ADD",      0, D_l,  2, O_dat,  O_T,    3, 70, O_siz, O_dL,   O_dH,    0, 0 },
{"SUB",      1, D_l,  2, O_A,    O_T,    1, 71, O_siz,   0,      0,     0, 0 },
{"SUB",      1, D_l,  2, O_T,    O_A,    1, 72, O_siz,   0,      0,     0, 0 },
{"SUB",      1, D_l,  2, O_dat,  O_A,    3, 73, O_siz, O_dL,   O_dH,    0, 0 },
{"SUB",      0, D_l,  2, O_dat,  O_T,    3, 74, O_siz, O_dL,   O_dH,    0, 0 },
{"MUL",      1, D_l,  2, O_A,    O_T,    1, 75, O_siz,   0,      0,     0, 0 },
{"MUL",      1, D_l,  2, O_T,    O_A,    1, 76, O_siz,   0,      0,     0, 0 },
{"MUL",      1, D_l,  2, O_dat,  O_A,    3, 77, O_siz, O_dL,   O_dH,    0, 0 },
{"MUL",      0, D_l,  2, O_dat,  O_T,    3, 78, O_siz, O_dL,   O_dH,    0, 0 },
{"DIV",      1, D_l,  2, O_A,    O_T,    1, 79, O_siz,   0,      0,     0, 0 },
{"DIV",      1, D_l,  2, O_T,    O_A,    1, 80, O_siz,   0,      0,     0, 0 },
{"DIV",      1, D_l,  2, O_dat,  O_A,    3, 81, O_siz, O_dL,   O_dH,    0, 0 },
{"DIV",      0, D_l,  2, O_dat,  O_T,    3, 82, O_siz, O_dL,   O_dH,    0, 0 },

{"WAITINT",  0, D_nd, 0,   0,      0,    1, 83, O_siz,   0,      0,     0, 0 },
{"WAITEVENT",0, D_nd, 0,   0,      0,    1, 84, O_siz,   0,      0,     0, 0 },

{"BR",       0, D_nd, 1, O_labl,   0,    2, 85, O_siz, O_labl,   0,     0, 0 },
{"BEQ",      0, D_nd, 2, O_dat,  O_labl, 4, 86, O_siz, O_labl, O_dL,  O_dH,0 },
{"BNE",      0, D_nd, 2, O_dat,  O_labl, 4, 87, O_siz, O_labl, O_dL,  O_dH,0 },
{"BGT",      0, D_nd, 2, O_dat,  O_labl, 4, 88, O_siz, O_labl, O_dL,  O_dH,0 },
{"BGE",      0, D_nd, 2, O_dat,  O_labl, 4, 89, O_siz, O_labl, O_dL,  O_dH,0 },
{"BLT",      0, D_nd, 2, O_dat,  O_labl, 4, 90, O_siz, O_labl, O_dL,  O_dH,0 },
{"BLE",      0, D_nd, 2, O_dat,  O_labl, 4, 91, O_siz, O_labl, O_dL,  O_dH,0 },
{"BBC",      0, D_nd, 2, O_dat,  O_labl, 4, 92, O_siz, O_labl, O_dL,  O_dH,0 },
{"BBS",      0, D_nd, 2, O_dat,  O_labl, 4, 93, O_siz, O_labl, O_dL,  O_dH,0 },

{"CLOSE",    0, D_nd, 0,   0,      0,    1,  0, O_siz,   0,      0,     0, 0 },
{"STOP",     0, D_nd, 0,   0,      0,    1,  0, O_siz,   0,      0,     0, 0 },

{"NOP",      0,   0,  0,   0,      0,    0, -1,   0,     0,      0,     0, 0 }
};
