/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

#include "camlib.h"    /* for just NAF */

#define BSIZE 10000
#define NTIMES 1

error_exit(status)
int status; {
    perror(strerror(status));
    exit(status);
};

short buffer[BSIZE];
short lst[3000];

/* Main */
main() {
    int status, i, q, x, ii, z,mode,rlist,error;
    short j;
    int slot,function,address;
    struct cc_iosb iosb;

/* Initialization part */
    status = CAM_Open( );
    if( status ) error_exit(status);
    printf("CAM_Open : OK\n");
    status = CSETBR(0);
    if( status ) error_exit(status);
    printf("CSETBR   : OK\n");
    status = CSETCR(0);
    if( status ) error_exit(status);
    printf("CSETCR   : OK\n");
    status = CGENZ();
    if( status ) error_exit(status);
    printf("CGENZ    : OK\n");
    status = CGENC();
    if( status ) error_exit(status);
    printf("CGENC    : OK\n");
    status = CSETI();
    if( status ) error_exit(status);
    printf("CSETI    : OK\n");
    status = CREMI();
    if( status ) error_exit(status);
    printf("CREMI    : OK\n");
    CKINIT();
    CRLIST("list.obj",lst,3000,&rlist,&error);
    if(CKADD("list",lst,rlist) != 0) printf("error in adding the list\n");
    CRLIST("lst2.obj",lst,3000,&rlist,&error);
    if(CKADD("lst2",lst,rlist) != 0) printf("error in adding the list\n");
    system("date");
    for(i=0;i<NTIMES;i++) {
      if(CKEXEC("list",buffer,BSIZE,&iosb) != 0) 
	printf("Error %d\n",i);
    }
    system("date");
    sleep(1);
    for(i=0;i<NTIMES;i++) if(CKEXEC("lst2",buffer,BSIZE,&iosb) != 0) 
      printf("Error %d\n",i);
    system("date");
    CKSAVE("list.klist");
    CKLOAD("list.klist");
    CKEXEC("list",buffer,BSIZE,&iosb);
}



