/*---------------------------------------------------------------*/
/*                                                               */
/*      example.h                                                */
/*      Donald Brenner                                           */
/*      Superconducting Super Collider Laboratory                */
/*      December 10, 1992                                        */
/*                                                               */
/*      This is an example of a header file which is used by     */
/*  example.c to show a user how to create a new process.        */
/*                                                               */
/*---------------------------------------------------------------*/


#include "generic.h"

/*---------------------------------------------------------------*/
/*        Definitions for the User Variable Dictionary           */
/*---------------------------------------------------------------*/
   /*----------------------------------------------*/
   /*                                              */
   /*  First declare the variable                  */
   /*                                              */
   /*----------------------------------------------*/

char event_sink[20];

   /*----------------------------------------------*/
   /*                                              */
   /*  Next add variable to the dictionary.        */
   /*                                              */
   /*----------------------------------------------*/

struct var_dict_type var_dict_usr[20] = {
   "event_sink", STRING, (int) event_sink 
};

int var_number_usr = 1; /* The number of variables declare above */


/*---------------------------------------------------------------*/
/*        Definitions for the User Command Dictionary            */
/*---------------------------------------------------------------*/

   /*----------------------------------------------*/
   /*                                              */
   /*  First declare the function(s) which         */
   /*  corresponds to the new command.             */
   /*                                              */
   /*----------------------------------------------*/

int Test();
int ExitR();

   /*----------------------------------------------*/
   /*                                              */
   /*  Next add command(s) to the dictionary.      */
   /*                                              */
   /*----------------------------------------------*/
 
struct cmd_dict_type cmd_dict_usr[20] = {
   "TEST", (int (*)()) Test,
   "EXIT",(int (*)()) ExitR
};
 
int cmd_number_usr = 2;   /* The number of command(s) declare above */

 

