/*---------------------------------------------------------------*/
/*                                                               */
/*      Cengiz ERBAS                                             */
/*      Superconducting Super Collider Laboratory                */
/*      June 20, 1992                                            */
/*        This is file variable.h                                */
/*                                                               */
/*---------------------------------------------------------------*/


/*---------------------------------------------------------------*/
/*       Definitions for the System Variable Dictionary          */
/*---------------------------------------------------------------*/
struct var_dict_type {
   char name[VAR_NAME];
   int  type;
   int  addr;
};

int debug_level = 0;
int status = 0;
int proc_status = ALIVE;
char process_name[20] = "collector";

struct var_dict_type var_dict_sys[30] = {
   "debug_level", INTEGER, (int) &debug_level,
   "process_name", STRING, (int) process_name,
   "status", INTEGER, (int) &status,
   "proc_status",INTEGER, (int) &proc_status
};

int var_number_sys = 4;

extern struct var_dict_type var_dict_usr[];
extern int var_number_usr;


/*---------------------------------------------------------------*/
/*       Definitions for the System Command Dictionary           */
/*---------------------------------------------------------------*/
struct cmd_dict_type {
   char name[CMD_NAME];
   int  (*proc_addr)();
};

int Ackn();
int Ask();
int Exit();
int GetPar();
int Mail();
int Reply();
int Set();
int SetPar();
int Shell();
int Show();
int Tell();

struct cmd_dict_type cmd_dict_sys[30] = {
   "ACKN", (int (*)()) Ackn,
   "ASK", (int (*)()) Ask,
   "EXIT", (int (*)()) Exit,
   "MAIL", (int (*)()) Mail,
   "REPLY", (int (*)()) Reply,
   "SET", (int (*)()) Set,
   "SHELL", (int (*)()) Shell,
   "SHOW", (int (*)()) Show,
   "TELL", (int (*)()) Tell,
   "GETPAR", (int (*)()) GetPar,
   "SETPAR", (int (*)()) SetPar
};

int cmd_number_sys = 11;

extern struct cmd_dict_type cmd_dict_usr[20];
extern int cmd_number_usr;
