%{
#include <string.h>
#include "yERR.tab.h"

#define MAX_ID 5

extern char hexstring[], octstring[], decstring[], groupstring[];
extern char keystring[], txtstring[], idstring[],sevstring[];
extern char helpfile[],commentstring[];
extern char inputline[];
extern char EOL;

extern void upcpy();
extern int  yywrap();
extern int  atoi();
extern int yyback();
extern int yylook();
extern void yyerror();

extern char *idlist[];
extern int currentid;

%}

%%

0x[0-9a-fA-F]+ { strcat(inputline,yytext);
		 sscanf(yytext,"0x%x",&yylval.int_val);
		 return HEXNUMB; }

0X[0-9a-fA-F]+ { strcat(inputline,yytext);
	 	 sscanf(yytext,"0X%X",&yylval.int_val);
		 return HEXNUMB; }

0[0-7]+	{strcat(inputline,yytext);
	 sscanf(yytext,"0%o",&yylval.int_val);
	 return OCTNUMB; }

[0-9]+		{strcat(inputline,yytext);
		 yylval.int_val = atoi(yytext);
	         return DECNUMB; }
\#[a-zA-Z_]*	{ if (strcmp(yytext,"#define") == 0)
	             return DEFINE;
		  else
		     {
		     while(strcmp(&yytext[yyleng-1],"\n") != 0)
		        {
	                yymore();
	                nstr = yylook();
	 	 	}
		     return IGNORE;
		     }
		}

"("		{yylval.int_val = LEFT_PAREN; return LEFT_PAREN;}
")"		{yylval.int_val = RIGHT_PAREN; return RIGHT_PAREN;}
"+"		{yylval.int_val = PLUS; return PLUS;}

[_a-zA-Z][-._a-zA-Z0-9]* 
	{     strcpy(idstring,yytext);
	      if (currentid >= MAX_ID)
	         {
		 yyerror("ID INDEX OUT OF RANGE !!!");
		 return(OOPS);
	         }
	      idlist[currentid] = (char *)malloc(strlen(yytext)+1);
	      sprintf(idlist[currentid],"%s",idstring);
	      yylval.char_ptr = idlist[currentid];
	      currentid++;
	      return ID; 
	}

"/*".*"*/"  {
	      strcat(inputline,yytext); strcpy(commentstring,yytext);  
              yylval.char_ptr = commentstring;
	      return COMMENT;
	    }

"/*"    {  while(strcmp(&yytext[yyleng-2],"*/") != 0)
           {
	       if (yyleng < YYLMAX) yymore();
	       nstr = yylook();
	   }
	   strcat(inputline,yytext);
	   strcpy(commentstring,yytext);
	   yylval.char_ptr = commentstring;
	   return COMMENT;
	}
.	{/*skip all else */}
[ \t]+	{strcat(inputline,yytext); /* skip blanks */}
\n	{ /*strcat(inputline,yytext); */
	 return(ENDMARKER);/* skip new lines */}
