	program testclient

#ifdef MUR_VMS
	include 'murmur_client$library:mur_f_user.inc'
	include 'murmur_client$tests:demo_msg_F.inc'
#else
#include "mur_f_user.inc"
#include "demo_msg_F.inc"
#endif
	integer i
	integer status
	integer errno, murcode
	integer seed
	double precision d /99.9/

#ifdef MUR_VMS
	include '($ssdef)'
#else
#include "ssdef.inc"
#endif

	status = mur_set_proc_name_f('TESTCLIENT')
	if ( mur_msg_fail_f(status)) stop 'MUR_SET_PROC_NAME failure'

	type *, 'Sending standard Set of DEMO Messages...'
	status = mur_send_text_f('Standard Set of DEMO Messages Following')
	if ( MUR_MSG_FAIL_F(status)) stop 'MUR_SEND_TEXT failure'

	status = MUR_SEND_F(DEMO_SUCCESS,0)
	if (  MUR_MSG_FAIL_F(status))stop 'MUR_SEND failure'

	status = MUR_SEND_F(DEMO_WARNING,0)
	if (  MUR_MSG_FAIL_F(status))stop 'MUR_SEND failure'

	status = MUR_SEND_F(DEMO_INFORM,0)
	if (  MUR_MSG_FAIL_F(status))stop 'MUR_SEND failure'

	status = MUR_SEND_F(DEMO_TEST_FORMATS,3,
     &			    MUR_STRING,'Mbula Was Here',
     &			    MUR_LONG,-123,
     &			    MUR_U_LONG,456)
	if (  MUR_MSG_FAIL_F(status))stop 'MUR_SEND failure'

	status = MUR_SEND_F(DEMO_ERROR,0)
	if (  MUR_MSG_FAIL_F(status))stop 'MUR_SEND failure'

	STATUS = MUR_SEND_F(DEMO_MORE_INFORM,1,MUR_APPEND,
     &		  	    '*** Adding to What You know ***')
	if (  MUR_MSG_FAIL_F(status))stop 'MUR_SEND failure'

	status = MUR_SEND_F(DEMO_FLOAT,1,MUR_FLOAT,d)
	if (  MUR_MSG_FAIL_F(status))stop 'MUR_SEND failure'


	type *, 'Sending VMS System Messages...'
	status = MUR_SEND_TEXT_F('VMS System Messages Following')
	if (  MUR_MSG_FAIL_F(status)) stop 'MUR_SEND_TEXT failure'

	status = MUR_TRANSLATE_VMS_F(SS$_NORMAL,murcode)
	if (  MUR_MSG_FAIL_F(status)) stop 'MUR_TRANSLATE_VMS failure'
	status = MUR_SEND_F(murcode,0)
	if (  MUR_MSG_FAIL_F(status)) stop 'MUR_SEND failure'

	status = MUR_TRANSLATE_VMS_F(SS$_BADPARAM,murcode)
	if (  MUR_MSG_FAIL_F(status)) stop 'MUR_TRANSLATE_VMS failure'
	status = MUR_SEND_F(murcode,0)
	if (  MUR_MSG_FAIL_F(status)) stop 'MUR_SEND failure'

	status = MUR_TRANSLATE_VMS_F(SS$_EXQUOTA,murcode)
	if (  MUR_MSG_FAIL_F(status)) stop 'MUR_TRANSLATE_VMS failure'
  	status = MUR_SEND_F(murcode,0)
	if (  MUR_MSG_FAIL_F(status)) stop 'MUR_SEND failure'

	status = MUR_TRANSLATE_VMS_F(SS$_NOPRIV,murcode)
	if (  MUR_MSG_FAIL_F(status)) stop 'MUR_TRANSLATE_VMS failure'
	status = MUR_SEND_F(murcode,0)
	if (  MUR_MSG_FAIL_F(status)) stop 'MUR_SEND failure'

	status = MUR_TRANSLATE_VMS_F(SS$_ACCVIO,murcode)
	if (  MUR_MSG_FAIL_F(status)) stop 'MUR_TRANSLATE_VMS failure'

	status = MUR_SEND_F(murcode,4,MUR_U_LONG,4,
     &				      MUR_U_LONG,12345,
     &				      MUR_U_LONG,0,
     &				      MUR_U_LONG,0)
	if (  MUR_MSG_FAIL_F(status)) stop 'MUR_SEND failure'

	type *, 'Sending ERRNO Messages...'
	status = MUR_SEND_TEXT_F('ERRNO Messages Following')
	if (  MUR_MSG_FAIL_F(status)) stop 'MUR_SEND_TEXT failure'

	seed = 135367059
	DO i=1,5
	  errno = ran(seed)*65 + 1
	  status = MUR_TRANSLATE_UNIX_F(errno,murcode)
	  if (  MUR_MSG_FAIL_F(status))stop 'MUR_TRANSLATE_UNIX failure'

	  status = MUR_SEND_F(murcode,0)
	  if (  MUR_MSG_FAIL_F(status))stop 'MUR_SEND failure'
	ENDDO

	STOP	'End of TESTCLIENT'
	END
