/* ////////////////////////////////////////////////////////
//
// file:    operator_win.C
// author:  C. Timmermans
// version: 1.0
// date:    9/30/92
/////////////////////////////////////////////////////// */

/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

#include"operator.h"

#include <X11/Xlib.h>
#include <stdlib.h>
#include <stdio.h>

extern char ownpname[15];

int i_message,message_mask;

extern Window com_line,cl_But;
extern Window storage;
extern Window run_control;
extern Window run_par,rp_bt[];
extern int n_rp_but;
extern struct rp_def rp_but[];

extern char comm_str[MAX_STR_LEN];
extern char comm_str2[MAX_STR_LEN];
extern char prompt_str[50];

XEvent report;

/* ////////////////////////////////////////////////////////////////////
// Init_screen: initializes the screen and creates the 4 different
// input windows.
/////////////////////////////////////////////////////////////////// */
Init_screen(name)
char *name;
{
#ifdef _DEBUG
	printf("Initializing the display\n");
#endif
	if(gui_init(NULL) < 0){
	  perror("Cannot initialize the display\n");
	  exit(1);
	}
	
	Init_win_runpar();
	if(strcmp(name,"operator") == 0) Init_win_runco();
	Init_win_storage();
	Init_win_comline();
	i_message = 0;
	message_mask = 0;
}
/* ////////////////////////////////////////////////
// wait for any X-event
//////////////////////////////////////////////// */
Wait_for_screen()
{
#ifdef _DEBUG
	printf("Waiting for an X-event\n");
#endif
	gui_next(&report);
#ifdef _DEBUG
	printf("Received Event\n");
#endif
}
Update_screen()
/* ////////////////////////////////////////////////
// checks if the screen is up to date with the runpar
// and storage parameters. In this way the window-manager
// needs only to be 'signalled' to make an update; otherwise
// elaborate messages need to be sended
///////////////////////////////////////////////////// */
{
#ifdef _DEBUG
	printf("Check if screen needs to be updated\n");
#endif
	Update_win_runpar();
	Update_win_storage();
}
Execute_screen()
/* ////////////////////////////////////////////////////////
// After receiving a message execute screen is called
/////////////////////////////////////////////////////// */
{
#ifdef _DEBUG
	printf("Executing the screen\n");
#endif
	Update_screen();
	if(message_mask != 0)        react_to_message(); 
	while(gui_pending()) {
	  gui_next(&report);
/* /////////////////////////////////////////////////////////
// Update the window that has been changed through the
// screen-actions of the operator.
///////////////////////////////////////////////////////// */
	  Execute_win_runpar();
	  Execute_win_storage();
	  if(strcmp(ownpname,"operator") == 0) Execute_win_runco();
	  Execute_win_comline();
	}
}

react_to_message()
/* ///////////////////////////////////////////////////////////////
// receives a message from the parent process and sets appropriate
// flags (opens windows)
/////////////////////////////////////////////////////////////// */
{
  int i;
  char msg[100];
  
  report.type = Expose;
  
  if(i_message == 0) {
    if((message_mask & MSG_RUN) != 0) {
      i_message = MSG_RUN;
      message_mask = message_mask - MSG_RUN;
      for(i = 0;i<n_rp_but;i++) {
	if(rp_but[i].rc_mod == NO) gui_hide(&(rp_bt[i]));
      }
      gui_hide(&run_control);
      gui_hide(&storage);
      gui_display(&cl_But);
      strcpy(comm_str2,"Press Button if runparameters are OK");
      gui_clear(&com_line);
      update_com_line();
    }
    else if((message_mask & MSG_STOR ) != 0) {
      i_message = MSG_STOR;
      message_mask = message_mask - MSG_STOR;
      gui_hide(&run_control);
      gui_hide(&run_par);
      gui_display(&cl_But);
      strcpy(comm_str2,"Press Button if storage parameters are OK");
      gui_clear(&com_line);
      update_com_line();
      gui_clear(&storage);
      update_storage();
    }
    else if ((message_mask & MSG_PROMPT) != 0) {
      i_message = MSG_PROMPT;
      message_mask = message_mask - MSG_PROMPT;
      gui_hide(&run_control);
      gui_hide(&run_par);
      gui_hide(&storage);
      strcpy(comm_str,prompt_str);
      strcpy(comm_str2,"Please give the following information");
      gui_clear(&com_line);
      update_com_line();
    }
  }
}
