/***************************************************************
 This is file runp_conv.c containing conversion routines for 
 operator variable displays. These routines require 3 input parameters.

 int routine(val,txt,dir)
 int *val,dir;
 char *txt;
 {
   if(dir == 0){
    convert integer val to text txt. Return 0 if succesful
  }
  else {
    convert text txt to integer val. Return 0 if succesful
  }
 }
 ******************************************************************/

/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

#include "operator.h"
#include<sys/types.h>
#include<time.h>
#include<sys/time.h>
#include<string.h>

char status_str[MAX_RUN_STATES][20] = {STR_RUN_STATES};


int conv_time(val,txt,dir)
/***********************************************************
 converts an integer, representing time in seconds since 
 January 1, 1970 into a string. It is not needed to translate
 the string back into an integer.
 ***********************************************************/
int *val,dir;
char *txt;
{
  u_long tm;

  if(dir == 0) {
    if (*val < 0) return(-1);
    if (*val == 0) txt[0] = '\0';
    else {
      tm = (u_long)(*val);
      strcpy(txt,ctime((time_t *)(&tm)));
      txt[19] = '\0';
    }
  }
  return(0);
}

int conv_stat(val,txt,dir)
/***************************************************************
 convert an integer, representing the status of a run into a 
 descriptive string, and back
 ***************************************************************/
int *val,dir;
char *txt;
{
  int i;

  if(dir == 0){
    if(*val < 0 || *val >= MAX_RUN_STATES) return(-1);
    strcpy(txt,status_str[*val]);
  }
  else{
    *val = -1;
    for(i = 0;i<MAX_RUN_STATES;i++){
      if(strcmp(txt,status_str[i]) == 0) {
	*val = i;
	break;
      }
    }
  }
  return(0);
}
