/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

#include <rpc/rpc.h>
#include "ipc_msg.h"


bool_t
xdr_rsp_send(xdrs, objp)
	XDR *xdrs;
	rsp_send *objp;
{
	if (!xdr_vector(xdrs, (char *)objp->procname, 100, sizeof(char), xdr_char)) {
		return (FALSE);
	}
	if (!xdr_vector(xdrs, (char *)objp->varname, 100, sizeof(char), xdr_char)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rsp_ret(xdrs, objp)
	XDR *xdrs;
	rsp_ret *objp;
{
	if (!xdr_short(xdrs, &objp->type)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->i_val)) {
		return (FALSE);
	}
	if (!xdr_float(xdrs, &objp->f_val)) {
		return (FALSE);
	}
	if (!xdr_vector(xdrs, (char *)objp->s_val, 150, sizeof(char), xdr_char)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->rtcode)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rsp_send_all(xdrs, objp)
	XDR *xdrs;
	rsp_send_all *objp;
{
	if (!xdr_vector(xdrs, (char *)objp->procname, 100, sizeof(char), xdr_char)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->valsize)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->varsize)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_rsp_ret_all(xdrs, objp)
	XDR *xdrs;
	rsp_ret_all *objp;
{
	if (!xdr_vector(xdrs, (char *)objp->type, 100, sizeof(short), xdr_short)) {
		return (FALSE);
	}
	if (!xdr_vector(xdrs, (char *)objp->i_val, 100, sizeof(int), xdr_int)) {
		return (FALSE);
	}
	if (!xdr_vector(xdrs, (char *)objp->f_val, 100, sizeof(float), xdr_float)) {
		return (FALSE);
	}
	if (!xdr_vector(xdrs, (char *)objp->varname, 5000, sizeof(char), xdr_char)) {
		return (FALSE);
	}
	if (!xdr_vector(xdrs, (char *)objp->s_val, 5000, sizeof(char), xdr_char)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->n_var)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->rtcode)) {
		return (FALSE);
	}
	return (TRUE);
}


