/*************************************************
 * camac.sig.c,v
*************************************************/
/*---------------------------------------------------------------*/
/*                                                               */
/*      Cengiz ERBAS                                             */
/*      Superconducting Super Collider Laboratory                */
/*      June 20, 1992                                            */
/*                                                               */
/*---------------------------------------------------------------*/

/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <signal.h>
#include <errno.h>
#include "template.h"
#include "ask.h"

/* #ifdef CAMAC_K2917 */

#include "camlib.h"
#define  L2249  7

/* #endif */

void sig_handler();
int flag;

/*(a+out) ------------------------------------------------- */
main (argc, argv)
int argc;
char *argv[];
/*(b+out) ------------------------------------------------- 
Procedure Name
Main - main procedure of pseudo
Synopsis
Description
main() is the main procedure of pseudo.

Superconducting Super Collider Laboratory 1.0
(c+out) --------------------------------------------------- */

{
   int  value, index;
   int  mask, dat, q, x;
   char msg[256], string[256];
   Table entry;

   /*
    *   Initialize the Common Table and the Message Queue
    */
   if (Attach_Table() == -1)
      printf("Error in Attach_Table()\n");

   index = Search_Table("collector");
   if (index == -1) {
      printf("No such process...\n");
      exit(1);
   } 
   Read_from_Table(&entry, index);

/* #ifdef CAMAC_K2917 */
   
   mask = 1 << (L2249 - 1);
   CAMOPN();
   CSETBR(1);
   CSETCR(0);
   CGENC();
   CGENZ();
   CREMI();

   printf("Before CAM_Enable...\n");

   CAM_EnableLAM(mask);
   CAMAC(NAF(L2249, 0, 26), &dat, &q, &x);

/* #endif */
#ifdef SGI
   CESIG((int (*))sig_handler);
#else
   CESIG((void (*))sig_handler);
#endif

   while (TRUE) {
      flag = TRUE;
      CWSIG();
      while (flag == TRUE);
      kill(entry.process_id, EVENT_SIGNAL); 
      CAMAC(NAF(L2249, 11, 2), &dat, &q, &x);   
      CAMAC(NAF(L2249, 0, 10), &dat, &q, &x);  
   }

/*      if (CAM_WaitLAM(1000)) 
         printf("Timeout: ");
      kill(entry.process_id, EVENT_SIGNAL); 
      CAMAC(NAF(L2249, 11, 2), &dat, &q, &x);   
      CAMAC(NAF(L2249, 0, 10), &dat, &q, &x);  */ 
}


void sig_handler()
{
   printf("in interrupt handler\n");
   flag = FALSE;
}

